#include "migrate.h"

extern sched_t sched_list;

static int action_c;
static value tuple=0;

void counting_action(value v,value* v_addr)
{
  if(v != 0)
    action_c++;
}

void storing_action(value v,value* v_addr)
{
  if(v != 0){
    Store_field(tuple,action_c,v);
    action_c++;
  }
}

void assign_action(value v,value* v_addr)
{
  if(v != 0){
    *v_addr=Field(tuple,action_c);
    action_c++;
  }
}

void apply_local_roots(void (*action)(value,value*))
{
  action_c=0;
  do_local_roots(action,
		 caml_bottom_of_stack, 
		 caml_last_return_address,
		 caml_gc_regs,
		 local_roots);
}

value get_roots_tuple(value unit)
{
  apply_local_roots(counting_action);
  tuple=0;
  register_global_root(&tuple);
  tuple=alloc_tuple(action_c);
  apply_local_roots(storing_action);
  return tuple;
}

value get_tuple(value unit)
{
  return tuple;
}

value assign_roots(value tuple_p)
{
  tuple=tuple_p;
  apply_local_roots(assign_action);
}

char *curr_top;
jmp_buf context;
int fd_in;

value marshal_curr_cont(value out_chan)
{
  char dumb;

  // PAS ENCORE ADAPTE AU RESEAU

  if(setjmp(context) == 0){
    curr_top=(char*)context->__jmpbuf[JB_SP];
    int size=(int)(sched_list->current->stack+STACK_SIZE-curr_top);
    printf("top size %u\n",sched_list->current->stack);
    int fd_out=Int_val(out_chan);
    char *stack=&sched_list->current->stack;
    safe_write(fd_out, &stack, sizeof(char*));
    safe_write(fd_out, &context, sizeof(jmp_buf));
    safe_write(fd_out, curr_top, size);
 
    return Val_int(0);
  }
  else{
    curr_top=(char*)context->__jmpbuf[JB_SP];
    {
      int size=(int)(sched_list->current->stack+STACK_SIZE-curr_top);
      safe_read(fd_in, curr_top, size);
    }
    
    return Val_int(1);
  }
}

void show_context(jmp_buf context)
{
  int *buf=(int*)context;
  int i;
  for(i=0  ; i< sizeof(jmp_buf)/sizeof(int) ;  i++)
    printf("buf[i] = %u\n",buf[i]);
}

value apply_cont_from_chan(value in_chan,value tuple_p)
{
  char *stack;
  tuple=tuple_p;
  fd_in=Int_val(in_chan);//caml_channel_descriptor(in_chan));
  safe_read(fd_in,&stack, sizeof(char*));
  safe_read(fd_in,&context,sizeof(jmp_buf));
  {
    int diff=stack - sched_list->current->stack;
    printf("size %u %u %d\n",stack,sched_list->current->stack,diff);
    printf("1 %u\n",context->__jmpbuf[JB_BP]);
    context->__jmpbuf[JB_BP]-=diff;
    printf("1 %u\n",context->__jmpbuf[JB_BP]);
    printf("2 %u\n",context->__jmpbuf[JB_SP]);
    context->__jmpbuf[JB_SP]-=diff;
  }
  setcontext(context);
}
