open Printf;;
open Migrate;;

let file_tbl=Hashtbl.create 256;;

let init_list()=
  printf "Shared directorie is ?\n";flush stdout;
  let dir_name=Migrate.read_line() in
  let dir=Unix.opendir dir_name in
  Unix.chdir dir_name;
  try
    while true do
      Hashtbl.add file_tbl (Unix.readdir dir) ()
    done
  with End_of_file -> Unix.closedir dir
;;

let fd_in=ref Unix.stdin;;
let fd_out=ref Unix.stdout;;

let find_comp s=
  let rec loop comp=
    migrate comp;
    try
      Hashtbl.find file_tbl s
    with
      Not_found -> 
	if comp < !Migrate.last_comp then
	  loop (comp+1)
	else raise Not_found in
  loop 0
;;

let sched=create_scheduler();;

let thread home=
  init_list();
  let rec loop()=
    Printf.printf "List of commands\nList : l\nGet a file : g\nQuit : q\n? ";
    flush stdout;
    let q=Migrate.read_line() in
    if q = "l" then
      begin
	for i=0 to !Migrate.last_comp do
	  if i != home then
	    begin
	      migrate i;
	      let list=ref ("Share dir on computer "^
			    (string_of_int !computer)^"\n") in
	      Hashtbl.iter 
		(fun el dumb -> 
		  if (String.compare "." el != 0) && 
		    (String.compare el ".." != 0) then
		    list:=!list ^ el ^ "\n";) file_tbl;
	      list:=!list ^ "\n";
	      migrate home;
	      output_string stdout !list;
	      flush stdout;
	    end;
	done;
	loop()
      end
    else if q="g" then
      begin
	Printf.printf "File name\n? " ; flush stdout;
	let file_name=Migrate.read_line() in
	cooperate();
	(try
	  find_comp file_name
	with Not_found -> loop());
	(try
	  fd_in:=Unix.openfile file_name [Unix.O_RDONLY] 0
	with _ -> migrate home; loop());
	let comp= !computer in
	migrate home;
	let out=open_out file_name in
	fd_out:=Unix.descr_of_out_channel out;
	let buf=String.make 256 '0' in
	let rec transport()=
	  migrate comp;
	  let len=Unix.read !fd_in buf 0 256 in
	  if len > 0 then
	    begin
	      migrate home;
	      ignore(Unix.write !fd_out buf 0 len);
	      transport()
	    end in
	transport();
	Unix.close !fd_in;
	migrate home;
	Unix.close !fd_out;
	printf "File %s downloaded \n" file_name;
	loop()
      end
    else Pervasives.exit 0;
  in loop()
;;

for i=0 to !last_comp do
  Migrate.create thread i;
done;
Migrate.exit();;
